diff -rupN newpd/pd-0.45-0/tcl/dialog_gui.tcl pd-0.45-0/tcl/dialog_gui.tcl
--- newpd/pd-0.45-0/tcl/dialog_gui.tcl	1969-12-31 19:00:00.000000000 -0500
+++ pd-0.45-0/tcl/dialog_gui.tcl	2013-08-27 12:37:35.806358982 -0400
@@ -0,0 +1,235 @@
+package provide dialog_gui 0.1
+package require dialog_prefs
+
+namespace eval ::dialog_gui:: {
+    namespace export create_gui_dialog
+}
+
+####################### gui dialog ##################3
+
+proc ::dialog_gui::apply {mytoplevel} {
+    # nothing to do
+}
+
+proc ::dialog_gui::cancel {mytoplevel} {
+#    pdsend "$mytoplevel cancel"
+}
+
+proc ::dialog_gui::ok {mytoplevel} {
+    ::dialog_gui::apply $mytoplevel
+    ::dialog_gui::cancel $mytoplevel
+}
+
+proc ::dialog_gui::setswatch {b swatch} {
+    $b configure -image $swatch
+}
+
+# this is triggered whenever the ::gui_preset
+# variable is written to
+proc ::dialog_gui::set_gui_preset {args} {
+    set choice $::gui_preset
+    switch $choice {
+        Default {
+            set ::pd_colors(atombox)       white
+            set ::pd_colors(atombox_border) black
+            set ::pd_colors(canvas_bg)     white
+            set ::pd_colors(canvas_cursor) black
+            set ::pd_colors(text)          black
+            set ::pd_colors(box)           white
+            set ::pd_colors(box_border)    black
+            set ::pd_colors(msg_box)       white
+            set ::pd_colors(msg_box_border) black
+            set ::pd_colors(iemgui_border) black
+            set ::pd_colors(cord_control)  black
+            set ::pd_colors(cord_signal)   black
+            set ::pd_colors(inlet)         black
+            set ::pd_colors(outlet)        black
+            set ::pd_colors(xlet_hover)    grey
+            set ::pd_colors(link)          blue
+            set ::pd_colors(selected)      blue
+            set ::pd_colors(selection_rectangle) black
+            set ::pd_colors(highlighted_text) black
+            set ::pd_colors(highlighted_text_bg) #c3c3c3
+        }
+        Inverted {
+            set ::pd_colors(atombox)       black
+            set ::pd_colors(atombox_border) white
+            set ::pd_colors(canvas_bg)     black
+            set ::pd_colors(canvas_cursor) white
+            set ::pd_colors(text)          white
+            set ::pd_colors(box)           black
+            set ::pd_colors(box_border)    white
+            set ::pd_colors(msg_box)       black
+            set ::pd_colors(msg_box_border) white
+            set ::pd_colors(iemgui_border) white
+            set ::pd_colors(cord_control)  white
+            set ::pd_colors(cord_signal)   white
+            set ::pd_colors(inlet)         white
+            set ::pd_colors(outlet)        white
+            set ::pd_colors(xlet_hover)    white
+            set ::pd_colors(link)          blue
+            set ::pd_colors(selected)      #ffff00
+            set ::pd_colors(selection_rectangle) white
+            set ::pd_colors(highlighted_text) white
+            set ::pd_colors(highlighted_text_bg) #3c3c3c
+        }
+        L2ork    {
+            set ::pd_colors(atombox)       #e0e0e0
+            set ::pd_colors(atombox_border) #c1c1c1
+            set ::pd_colors(canvas_bg)     white
+            set ::pd_colors(canvas_cursor) black
+            set ::pd_colors(text)          black
+            set ::pd_colors(box)           #f6f8f8
+            set ::pd_colors(box_border)    #c1c1c1
+            set ::pd_colors(msg_box)       #f6f8f8
+            set ::pd_colors(msg_box_border) #c1c1c1
+            set ::pd_colors(iemgui_border) black
+            set ::pd_colors(cord_control)  black
+            set ::pd_colors(cord_signal)   #828297
+            set ::pd_colors(inlet)         #536253
+            set ::pd_colors(outlet)        #536253
+            set ::pd_colors(xlet_hover)    grey
+            set ::pd_colors(link)          #e87216
+            set ::pd_colors(selected)      #e87216
+            set ::pd_colors(selection_rectangle) #e87216
+            set ::pd_colors(highlighted_text) black
+            set ::pd_colors(highlighted_text_bg) #c3c3c3
+        }
+        L2ork_Inverted {
+            set ::pd_colors(atombox)       black
+            set ::pd_colors(canvas_bg)     black
+            set ::pd_colors(canvas_cursor) white
+            set ::pd_colors(text)          white
+            set ::pd_colors(box)           #090707
+            set ::pd_colors(box_border)    #3e3e3e
+            set ::pd_colors(msg_box)       #090707
+            set ::pd_colors(msg_box_border) #3e3e3e
+            set ::pd_colors(iemgui_border) white
+            set ::pd_colors(cord_control)  white
+            set ::pd_colors(cord_signal)   #7d7d68
+            set ::pd_colors(inlet)         #a294a2
+            set ::pd_colors(outlet)        #a294a2
+            set ::pd_colors(xlet_hover)    white
+            set ::pd_colors(link)          blue
+            set ::pd_colors(selected)      #ffff00
+            set ::pd_colors(selection_rectangle) white
+            set ::pd_colors(highlighted_text) white
+            set ::pd_colors(highlighted_text_bg) #3c3c3c
+        }
+        Extended    {
+            set ::pd_colors(atombox)       #e0e0e0
+            set ::pd_colors(atombox_border) #c1c1c1
+            set ::pd_colors(canvas_bg)     white
+            set ::pd_colors(canvas_cursor) black
+            set ::pd_colors(text)          black
+            set ::pd_colors(box)           #f6f8f8
+            set ::pd_colors(box_border)    #c1c1c1
+            set ::pd_colors(msg_box)       #f6f8f8
+            set ::pd_colors(msg_box_border) #c1c1c1
+            set ::pd_colors(iemgui_border) black
+            set ::pd_colors(cord_control)  black
+            set ::pd_colors(cord_signal)   #828297
+            set ::pd_colors(inlet)         #536253
+            set ::pd_colors(outlet)        #536253
+            set ::pd_colors(xlet_hover)    grey
+            set ::pd_colors(link)          blue
+            set ::pd_colors(selected)      blue
+            set ::pd_colors(selection_rectangle) black
+            set ::pd_colors(highlighted_text) black
+            set ::pd_colors(highlighted_text_bg) #c3c3c3
+        }
+        C64   {
+            set ::pd_colors(atombox)       #3e32a2
+            set ::pd_colors(atombox_border) #7569d7
+            set ::pd_colors(canvas_bg)     #3e32a2
+            set ::pd_colors(canvas_cursor) white
+            set ::pd_colors(text)          #a49aea
+            set ::pd_colors(box)           #3e32a2
+            set ::pd_colors(box_border)    #7569d7
+            set ::pd_colors(msg_box)       #3e32a2
+            set ::pd_colors(msg_box_border) #7569d7
+            set ::pd_colors(iemgui_border) #7569d7
+            set ::pd_colors(cord_control)  #7569d7
+            set ::pd_colors(cord_signal)   #7569d7
+            set ::pd_colors(inlet)         #7c71da
+            set ::pd_colors(outlet)        #7c71da
+            set ::pd_colors(xlet_hover)    grey
+            set ::pd_colors(link)          #e87216
+            set ::pd_colors(selected)      #cc9933
+            set ::pd_colors(selection_rectangle) #7c71da
+            set ::pd_colors(highlighted_text) #3e32a2
+            set ::pd_colors(highlighted_text_bg) #a49aea
+        }
+        Strongbad {
+            set ::pd_colors(atombox)       black
+            set ::pd_colors(atombox_border) #0b560b
+            set ::pd_colors(canvas_bg)     black
+            set ::pd_colors(canvas_cursor) white
+            set ::pd_colors(text)          #4bd046
+            set ::pd_colors(box)           black
+            set ::pd_colors(box_border)    #0b560b
+            set ::pd_colors(msg_box)       black
+            set ::pd_colors(msg_box_border) #0b560b
+            set ::pd_colors(iemgui_border) #0b560b
+            set ::pd_colors(cord_control)  #53b83b
+            set ::pd_colors(cord_signal)   #53b83b
+            set ::pd_colors(inlet)         #53b83b
+            set ::pd_colors(outlet)        #53b83b
+            set ::pd_colors(xlet_hover)    white
+            set ::pd_colors(link)          blue
+            set ::pd_colors(selected)      green
+            set ::pd_colors(selection_rectangle) #53b83b
+            set ::pd_colors(highlighted_text) black
+            set ::pd_colors(highlighted_text_bg) #4bd046 
+        }
+        Subdued {
+            set ::pd_colors(atombox)       #9fc79f
+            set ::pd_colors(atombox_border) #b1d3b1
+            set ::pd_colors(canvas_bg)     #c0dcc0
+            set ::pd_colors(canvas_cursor) black
+            set ::pd_colors(text)          black
+            set ::pd_colors(box)           #c0dcc0
+            set ::pd_colors(box_border)    #666666
+            set ::pd_colors(msg_box)       #c0dcc0
+            set ::pd_colors(msg_box_border) #666666
+            set ::pd_colors(iemgui_border) #666666
+            set ::pd_colors(cord_control)  #333333
+            set ::pd_colors(cord_signal)   #666666
+            set ::pd_colors(inlet)         #333333
+            set ::pd_colors(outlet)        #333333
+            set ::pd_colors(xlet_hover)    white
+            set ::pd_colors(link)          blue
+            set ::pd_colors(selected)      blue
+            set ::pd_colors(selection_rectangle) #333333
+            set ::pd_colors(highlighted_text) black 
+            set ::pd_colors(highlighted_text_bg) #c3c3c3
+        }
+    }
+}
+
+proc ::dialog_gui::create_gui_dialog {mytoplevel} {
+    if [winfo exists $mytoplevel.colors] then return
+    set fr [ttk::frame $mytoplevel.colors]
+    set p [ttk::frame $fr.presets]
+    ttk::label $p.presetlabel -text "Color Preset"
+#    ttk::combobox $fr.presets -state readonly -values {Inverted L2ork Foo}
+# todo: set presets in _one_ place
+    ::dialog_prefs::dropdown $p.presets ::gui_preset {Default Inverted L2ork L2ork_Inverted Extended C64 Strongbad Subdued}
+    pack $fr -side top
+    grid $p -column 0 -columnspan 3 -row 0 -sticky w -pady 21
+    pack $p.presetlabel -side left -padx 7
+    pack $p.presets -side left
+    set clen [expr {[llength [array names ::pd_colors]] / 2}]
+    set i 0
+    foreach name [lsort [array names ::pd_colors]] {
+        set label [string map {_ " "} $name]
+        set label [string toupper $label 0 0]
+        ::dialog_prefs::swatchbutton $fr.$name ::pd_colors($name)
+        ::dialog_prefs::set_swatchbutton $fr.$name \
+            ::pd_colors($name)
+        ttk::label $fr.${name}label -text "$label"
+        grid $fr.${name} -column [expr $i/$clen * 2] -row [expr $i%$clen+1] -sticky e
+        grid $fr.${name}label -column [expr $i/$clen * 2 + 1] -row [expr $i%$clen+1] -sticky w -padx 7 -pady 3
+        incr i
+    }
+}
